leetcode 11盛水最多的容器

class Solution {
public:
    int maxArea(vector<int>& height) {
        //双指针法:从最宽的容器开始计算,当更窄的容器盛水量要大于之前容器,那必须比之前容器高,因此可以移动两个指针,直到最窄time O(n),space O(1);
        int low=0;
        int high=height.size()-1;
        int volume=0;
        while(low<high){
            int h=min(height[low],height[high]);
            volume=max(volume,h*(high-low));
            if(height[low]<height[high]){
                low++;
                while(low<high && height[low]<=h) ++low;
            }else{
                high--;
                while(low<high && height[high]<=h) --high;
            }
        }
        return volume;
    }
};

原文地址:https://www.cnblogs.com/joelwang/p/11007993.html

时间: 2024-11-05 21:59:56

leetcode 11盛水最多的容器的相关文章

LeetCode第11题 盛水最多的容器

/* 给定 n 个非负整数 a1,a2,...,an,每个数代表坐标中的一个点 (i, ai) . 在坐标内画 n 条垂直线,垂直线 i 的两个端点分别为 (i, ai) 和 (i, 0). 找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水. 说明:你不能倾斜容器,且 n 的值至少为 2.*/ 思路: 类似于木桶效应. 每次移动较短的线,保持长线不动.(如果短线不动而长线动,容量减小(y没有增大反而x变小)) 记录最大值. 1 class Solution11 { 2 3 pu

leetcode 盛水最多的容器(双指针)

给定 n 个非负整数 a1,a2,...,an,每个数代表坐标中的一个点 (i, ai) .在坐标内画 n 条垂直线,垂直线 i 的两个端点分别为 (i, ai) 和 (i, 0).找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水. 说明:你不能倾斜容器,且 n 的值至少为 2. 图中垂直线代表输入数组 [1,8,6,2,5,4,8,3,7].在此情况下,容器能够容纳水(表示为蓝色部分)的最大值为 49. 示例: 输入: [1,8,6,2,5,4,8,3,7]输出: 49 来源

盛水最多的容器

题目:给定 n 个非负整数 a1,a2,...,an,每个数代表坐标中的一个点 (i, ai) .在坐标内画 n 条垂直线,垂直线 i 的两个端点分别为 (i, ai) 和 (i, 0).找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水.说明:你不能倾斜容器,且 n 的值至少为 2.来源:https://leetcode-cn.com/problems/container-with-most-water/ 法一:双指针法 思路:由于是求最大的存水面积,易知影响存水面积S的只有两

[leetcode] 11.盛最多水的容器

盛最多水的容器 题意好绕,看半天都没懂要干什么. 我直接上个图可能就能一眼看明白了: 总之,当明白题意后,直接就能想到暴力法枚举所有可能性,不过如果再画一下图基本就能发现:两线段之间形成的区域总是会受到其中较短那条长度的限制. 我举个例子,对于所有以(1,a1)为左边构成的矩阵,最大的一个肯定在右边(n,an)开始数,第一个大于等于ai的边,我们记成aj.即以a1为左边的最大矩阵肯定是 以right边从(j,aj)~(n,an)构成矩阵中的其中一个.实际上,对于(1,a1)~(j,aj)的边,我

LeetCode 11 - 盛最多水的容器 - [双指针暴力]

题目链接:https://leetcode-cn.com/problems/container-with-most-water/description/ 给定 n 个非负整数 $a_1,a_2,\cdots,a_{n-1},a_n$,每个数代表坐标中的一个点 $(i, a_i)$.在坐标内画 n 条垂直线,垂直线 i 的两个端点分别为 $(i, ai_)$ 和 $(i, 0)$. 找出其中的两条线,使得它们与 $x$ 轴共同构成的容器可以容纳最多的水. 说明:你不能倾斜容器,且 $n$ 的值至少

Python版[leetcode]11. 盛最多水的容器(难度中等)

给定 n 个非负整数 a1,a2,...,an,每个数代表坐标中的一个点 (i, ai) .在坐标内画 n 条垂直线,垂直线 i 的两个端点分别为 (i, ai) 和 (i, 0).找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水. 说明:你不能倾斜容器,且 n 的值至少为 2.   图中垂直线代表输入数组 [1,8,6,2,5,4,8,3,7].在此情况下,容器能够容纳水(表示为蓝色部分)的最大值为 49.   示例: 输入: [1,8,6,2,5,4,8,3,7]输出: 4

leetcode——11.盛最多水的容器

双指针法: class Solution: def maxArea(self, height) -> int: if len(height)<=1: return 0 #双指针法 i,j,S=0,len(height)-1,0 while i<j: if height[i]<height[j]: S=max(S,height[i]*(j-i)) i+=1 else: S=max(S,height[j]*(j-i)) j-=1 return S 执行用时 :148 ms, 在所有 P

[leetcode]11. Container With Most Water存水最多的容器

Given n non-negative integers a1, a2, ..., an , where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of line i is at (i, ai) and (i, 0). Find two lines, which together with x-axis forms a contain

11. 盛最多水的容器

11. 盛最多水的容器 方法一 class Solution(object): def maxArea(self, height): """ :type height: List[int] :rtype: int """ h_len = len(height) i = 0 k = -1 s = [] while h_len + k - i >= 1: s.append(min(height[i], height[k]) * (h_len +